{-

SPS/APS - Security Protocol Specification langauge
Copyright Omar Saad Almousa, Technical Univerity of Denmark (DTU) 2013-2015

All Rights Reserved.

-}
module OperationalStrands where
import Analyze
import Msg
import StrandAST
import Ast
import ComposeM
import Preprocessor
import Data.List
import Data.Char
---------------------------------------------------------------
opStrands:: [Strand] -> [Strand]
opStrands []=[]
opStrands (x:xs)= (opStrand x) : (opStrands xs)
---------------------------------------------
-- you do need this opKnowledge since you have to differentiate later between initial knowledge(know) of a strand, and the extended (updated) knowledge during progress! a, know of the strand is enough!
-- you do not need checks to be separated from the strand,i.e., just append any checks to the strand
-- also append recipes (how to's) to the strand
opStrand :: Strand -> Strand
-- opStrand (Strand n o know rest) =     Strand n o know (opStrnd [] know know rest)
opStrand (Strand n o know rest) =     Strand n o know (opStrnd [] [] know rest)
-------------------------------------------------
opStrnd csc wl k  (Rcv det msg rest) = (Rcv det' l') (opStrnd csc'  wl'' k'' rest')
                                    where   l'= giveMeLabel k 1;
                                            k' = (l',msg):k;
                                            csc'= (snd' (analyze csc wl k)) ++ csc;
                                            wl' = (l',msg):wl;
                                            wl''= (opWl csc wl' k');
                                            k''=(opKnow csc wl' k') `union` wl'';
                                            rest' = (opChecks csc wl' k' rest);
                                            det' = composeDet (k'' `union` wl'') det -- ONE CAN'T RECEIVE FROM UNKNOW!
opStrnd csc k wl  (Snd det msg rest)= Snd det' (composE (k`union` wl) msg)     (opStrnd csc k wl  rest)
                                    where det' = composeDet (k`union` wl) det

opStrnd csc k wl  (V ver msg1 msg2 rest)            = V ver msg1 msg2                         (opStrnd csc k wl  rest)
opStrnd csc k wl  (How des msg1 msg2 msg3 rest)     = How des msg1 msg2 msg3                 (opStrnd csc k wl  rest)
opStrnd csc k wl  (Create msg1 msg2 msg3 rest)      = Create msg1 msg2     msg3                (opStrnd csc k wl  rest)
opStrnd csc k wl  (Fresh tipe ms orms rest) = Fresh (composeType (k `union` wl) tipe) (lstCmps (k' `union` wl') ms) orms (opStrnd csc k' wl'  rest)
                                                    where k'=k++(labelMsgList (ms ++ frshPriv tipe ms) (length (k `union` wl)));
                                                          wl'=wl ++(labelMsgList (ms ++ frshPriv tipe ms) (length (k `union` wl)));
opStrnd csc k wl  (EOS sessid)                      = EOS sessid
opStrnd csc k wl  (Connects rest)                   =                                         (opStrnd csc k wl  rest)
opStrnd csc k wl  s@(Add Witness id m p rest) = if(composable (k `union` wl) m && (and (map (composable (k `union` wl)) p))) then  
                                                Add Witness id (composE (k`union` wl) m) (map (composE (k`union` wl)) p) (opStrnd csc k wl  rest)
                                                else (opStrnd csc k wl (reArr s []))
                                                -- else (opStrnd csc k wl (reArrange s))
-- if(onlyGoalsLeft s) then Add Witness id (composE (k`union` wl) m) (map (composE (k`union` wl)) p) (opStrnd csc k wl  rest) else (opStrnd csc k wl (reArrange s))
opStrnd csc k wl  s@(Add e id m p rest)        = Add e id (composE (k`union` wl) m) (map (composE (k`union` wl)) p) (opStrnd csc k wl  rest) 
                                            
----------------------------------------------------------------
frshPriv (PublicKey _) ms =  genInvs ms 
frshPriv _ ms = []
genInvs [] =[]
genInvs (x:xs) =(Comp Inv [] [x]) : genInvs xs
-- reArrange is mainly to place Witness event where it is supposed to be i.e., the first place it is composable
reArrange (Add e id m p (Rcv det msg rest)) = Rcv det msg (Add e id m p rest)
reArrange (Add e id m p (Snd det msg rest)) = Snd det msg (Add e id m p rest)
reArrange (Add e id m p (V ver msg1 msg2 rest)) = V ver msg1 msg2 (Add e id m p rest)
reArrange (Add e id m p (How des msg1 msg2 msg3 rest)) = How des msg1 msg2 msg3 (Add e id m p rest)
reArrange (Add e id m p (Create msg1 msg2 msg3 rest)) = Create msg1 msg2 msg3 (Add e id m p rest)
reArrange (Add e id m p (Fresh tipe ms orms rest)) = Fresh tipe ms orms (Add e id m p rest)
reArrange (Add e id m p (EOS sessid)) = error("something wrong about goals, check "++ show(m)) -- reArrange s@(Add e id m p (EOS sessid)) = s
reArrange (Add e id m p (Connects rest)) = reArrange (Add e id m p rest)
reArrange s@(Add e1 id m p (Add e2 id2 m2 p2 rest)) = error("Something Wrong about goals, check:\n"++ show(m)++" and\n " ++show(m2)) 
-----------------------------------------------------------------------------
reArr (Add e id m p rest) lstOfAdds = reArr rest ((Add e id m p):lstOfAdds)
reArr (Connects rest) lstOfAdds = reArr rest lstOfAdds
-- reArr (Connects rest) lstOfAdds = error("Something Wrong about goals\n")
reArr (EOS _) lstOfAdds = error("Something Wrong about goals, some of them can't by composed by agents!\n")
reArr (Rcv det msg rest)  lstOfAdds = Rcv det msg ((lstToStrd lstOfAdds) rest)
reArr (Snd det msg rest) lstOfAdds = Snd det msg ((lstToStrd lstOfAdds) rest)
reArr (V ver msg1 msg2 rest) lstOfAdds = V ver msg1 msg2 ((lstToStrd lstOfAdds) rest)
reArr (How des msg1 msg2 msg3 rest) lstOfAdds = How des msg1 msg2 msg3 ((lstToStrd lstOfAdds) rest)
reArr (Create msg1 msg2 msg3 rest) lstOfAdds = Create msg1 msg2 msg3 ((lstToStrd lstOfAdds) rest)
reArr (Fresh tipe ms orms rest) lstOfAdds = Fresh tipe ms orms ((lstToStrd lstOfAdds) rest)
----------------------------------------------------------------------
-- lstToStrd [] = Connects
lstToStrd [x] = x
lstToStrd (x:xs) = x . (lstToStrd xs)
-----------------------
onlyGoalsLeft (Add e id m p rest) = onlyGoalsLeft rest
onlyGoalsLeft (EOS s) = True
onlyGoalsLeft _ = False
---------------------------------------------
-- converts a Strand0 to [Strand0]
strToLst  (Snd det m rest)                     = (Snd det m) : (strToLst  rest)
strToLst  (Rcv det m rest)                     = (Rcv det m) :  (strToLst  rest)
strToLst  (Fresh tps ms orms rest)             = (Fresh tps ms orms):(strToLst  rest)
strToLst  (V ver m1 m2 rest)                 = (V ver m1 m2):(strToLst rest)
strToLst  (Create m1 m2 m3 rest)            = (Create m1 m2 m3):(strToLst rest)
strToLst  (How des m1 m2 m3 rest)            =  How des m1 m2 m3: (strToLst rest)
strToLst  (Add event id m ps rest)            = Add event id m ps: strToLst rest
strToLst  (Connects rest)                    = strToLst rest
strToLst  (EOS id)                             =  [Connects]--[EOS id]
-------------------------------------------------------------
opKnow csc wl k = fst' (analyze csc wl k)
opChecks csc wl k = combineAll (snd' (analyze csc wl k))
opWl csc wl k = trd' (analyze csc wl k)
-------------------------------------------------------------
capFst (x:xs)= (toUpper x) : xs
capFst []=[]
---------------------
lstCmps k [] = []
lstCmps k (x:xs)= (composE k x) : (lstCmps k xs)